// WatchTVPro _DLL_Sample.h : Haupt-Header-Datei fr die DLL WATCHTVPRO _DLL_SAMPLE
//

#if !defined(AFX_WATCHTVPRO_DLL_SAMPLE_H__DA0C7880_6E16_4CD3_AC99_4B780B89293F__INCLUDED_)
#define AFX_WATCHTVPRO_DLL_SAMPLE_H__DA0C7880_6E16_4CD3_AC99_4B780B89293F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// Hauptsymbole
#include "Properties.h"

/*
#define MDAPI_GET_TRANSPONDER        0x01020000
#define MDAPI_SET_TRANSPONDER        0x01020001
#define MDAPI_RESCAN_PROGRAMM        0x01020012
#define MDAPI_SAVE_PROGRAMM          0x01020013
*/

#define MDAPI_GET_PROGRAMM           0x01020010
#define MDAPI_SET_PROGRAMM           0x01020011
#define MDAPI_GET_PROGRAMM_NUMMER    0x01020014
#define MDAPI_SET_PROGRAMM_NUMMER    0x01020015
#define MDAPI_START_FILTER           0x01020020		
#define MDAPI_STOP_FILTER            0x01020021		
#define MDAPI_START_OSD              0x01020040
#define MDAPI_OSD_DRAWBLOCK          0x01020041
#define MDAPI_OSD_SETFONT            0x01020042
#define MDAPI_OSD_TEXT               0x01020043
#define MDAPI_STOP_OSD               0x01020049

/*
#define MDAPI_SCAN_CURRENT_TP        0x01020030
#define MDAPI_SCAN_CURRENT_CAT       0x01020031
#define MDAPI_SEND_OSD_KEY           0x01020044
#define MDAPI_DVB_COMMAND            0x01020060
*/

#define WTVP_CHANNELS_COUNT			 0x01021000
#define WTVP_GET_VOLUME				 0x01021010
#define WTVP_SET_VOLUME				 0x01021011
#define	WTVP_SEND_DISEQC			 0x01021015
#define WTVP_MOVE_OSD				 0x01021020
#define WTVP_READ_REGISTRY			 0x01021046
#define WTVP_WRITE_REGISTRY			 0x01021045
#define WTVP_GET_TIMERRECORD	 	 0x01021050
#define WTVP_SET_TIMERRECORD		 0x01021055
#define WTVP_SET_OSD_SURFACE		 0x01021065
#define WTVP_FILE_PLAYBACK			 0x01021070
#define WTVP_OSD_LOADBMP			 0x01021080
#define	WTVP_SET_OSD_COLOR			 0x01021090
#define WTVP_OSD_OFF				 0x01021030
#define WTVP_OSD_ON					 0x01021035 

#define TIMER_RECORD	0
#define TIMER_SWITCH	1
#define TIMER_WEEK		2
#define TIMER_WEEKEND	3
#define TIMER_DAILY		4
#define TIMER_MONDAY	5
#define TIMER_TUESDAY	6
#define TIMER_WEDNESDAY	7
#define	TIMER_THURSDAY	8
#define TIMER_FRIDAY	9
#define	TIMER_SATURDAY	10
#define TIMER_SUNDAY	11

#define SEND_TO_WTVP_AND_DLLS	0
#define SEND_TO_DLLS_ONLY		1
#define	SEND_TO_WTVP_ONLY		2
#define SEND_TO_NOTHING_ELSE	3

#define	NoPalet 0
#define Pal1Bit 2       
#define	Pal2Bit 4       
#define	Pal4Bit 16
#define	Pal8Bit 256      

typedef struct
{
	int			iColorIndex;
	COLORREF	myColorRef;
	int			PaletteTyp;
}OSDCOLOR_SET;

typedef struct
{
	char	szFilename[MAX_PATH];
	int		posX;
	int		posY;
}BMP_Struct;

typedef struct
{
	CTime	Start;   //time_t (32Bit) the number of seconds elapsed since midnight (00:00:00), January 1, 1970
	CTime	Stop;	 
	char	Sendung[64];
	char	Sender[32];
	int		iChannelNumber;
	bool	bFav;			//  redundant
	int		iRecordingType; //  TIMER_xxx defined
} TimerData;

typedef struct
{
	int			iTimerNumber;
	int			iTimerCount;
	TimerData   theTimerData;
}WTVP_TimerRecord;

typedef struct  
{
	char FilterName[5];
	unsigned char FilterId;
	unsigned short PID;
} TPIDFilters;

typedef struct  
{
	unsigned short CA_Typ;
	unsigned short ECM;
	unsigned short EMM;
} TCA_System;

typedef struct 
{
	char				Name[30];
	char				Anbieter[30];
	char				Land[30];
    unsigned long		freq;
    unsigned char		Typ;
	unsigned char		volt;              
	unsigned char		afc;
	unsigned char		diseqc;            
	unsigned int		srate;         
	unsigned char		qam;               
	unsigned char		fec;   
	unsigned char		norm;
	unsigned short		tp_id;        
	unsigned short		Video_pid;        
	unsigned short		Audio_pid;
    unsigned short		TeleText_pid;          
	unsigned short		PMT_pid;
    unsigned short		PCR_pid;
	unsigned short		ECM_PID;
	unsigned short		SID_pid;
	unsigned short		AC3_pid;
	unsigned char		TVType; 
	unsigned char		ServiceTyp;
    unsigned char		CA_ID;
	unsigned short		Temp_Audio;
	unsigned short		Filteranzahl;
    TPIDFilters			Filters[12];
	unsigned short		CA_Anzahl;
    TCA_System			CA_System[6];
    char				CA_Land[5];
    unsigned char		Merker;
    unsigned short		Link_TP;
    unsigned short		Link_SID;
    unsigned char		Dynamisch;

    char Extern_Buffer[16];
} TProgramm;

typedef struct
{
	unsigned short	DLL_ID;
	unsigned short	Filter_ID;
	unsigned short	Pid;
	unsigned char	Name[32];
	DWORD			Irq_Call_Adresse;
	int				Running_ID;
} TSTART_FILTER ;

typedef struct 
{
	unsigned short x;
	unsigned short y;
	unsigned short Sizex;
	unsigned short Sizey;
	unsigned short Color;
} TOSD_DRAW ;
	 
typedef struct  
{
	unsigned short Typ;
	unsigned short Fg_Color;
	unsigned short Bg_Color;
} TOSD_SETFONT;
	 
typedef struct  
{
	unsigned short x;
	unsigned short y;
	char Zeile[128];
} TOSD_SETEXT;
	 
typedef struct  
{
    int			  DLL_Id;
	unsigned char BitTiefe;
	int			  x1;
	int			  y1;
	int			  x2;
	int			  y2;
	BOOL		  Input;
} TOSD_START; 

typedef struct
{
	int	x;
	int y;
} TOSD_MOVE;

typedef struct
{
	DWORD			dwDialogID;
	CRuntimeClass*	pClass;
}PROPERTY_INFO;

/////////////////////////////////////////////////////////////////////////////
// CWatchTVPro_DLL_SampleApp
// Siehe WatchTVPro _DLL_Sample.cpp fr die Implementierung dieser Klasse
//

class CWatchTVPro_DLL_SampleApp : public CWinApp
{
public:
	CWatchTVPro_DLL_SampleApp();

	void CWatchTVPro_DLL_SampleApp::SwitchStatus();

	HINSTANCE		App_hInstance;
	HWND    		App_hWindow;
	int				App_DLL_ID;
	TSTART_FILTER	StartFilter;
	CFile			myFile;
	CString			m_Sendername;
	int				iChannelCount;
	PROPERTY_INFO*	pProperties;
	WTVP_TimerRecord myTimerData;
	BMP_Struct		myBMPStruct;
	OSDCOLOR_SET	myColorSet;
	BOOL			bOSD;
	BOOL			bIsActive;

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CWatchTVPro_DLL_SampleApp)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CWatchTVPro_DLL_SampleApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_WATCHTVPRO_DLL_SAMPLE_H__DA0C7880_6E16_4CD3_AC99_4B780B89293F__INCLUDED_)
